import Taro from '@tarojs/taro'

function loadPlugin() {
  Taro.$global = createTaroGlobal()
  listenNetwork()

  Taro.pluginLogin({
    success(res) {
      const { code } = res || {}
      Taro.$global.userCode = code
      Taro.setStorageSync('userCode', code)
    }
  })
}

function createTaroGlobal() {
  const global = {
    systemInfo: Taro.getSystemInfoSync() || {},
    network: {},
    launchOption: {}
  }

  try {
    global.launchOption = Taro.getLaunchOptionsSync()
  } catch (e) {
    console.log('不支持 getLaunchOptionsSync')
  }

  return global
}

async function listenNetwork() {
  Taro.$global.network = await Taro.getNetworkType() || {}

  Taro.onNetworkStatusChange(({ networkType }) => {
    Taro.$global.network.networkType = networkType
  })
}

loadPlugin()
